import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
public class LifeView extends JPanel implements ActionListener {
   private LifeModel model;
   private LifeWorld world;
   private JButton stepButton = new JButton("Step");
   private JButton runButton = new JButton("Run");
   private JButton stopButton = new JButton("Stop");
   private JLabel generationLabel = new JLabel();
   private Timer timer = new Timer(200, this);

   public LifeView(LifeModel model, LifeWorld world) {
      this.model = model;
      this.world = world;
      JPanel buttonPanel = new JPanel();
      buttonPanel.setLayout(new GridLayout(1, 3));
      buttonPanel.add(stepButton); 
      buttonPanel.add(runButton); 
      buttonPanel.add(stopButton); 
      generationLabel.setText("Generation: " + model.getNrOfGeneration());
      JPanel southPanel = new JPanel();
      southPanel.setLayout(new GridLayout(2,1));
      southPanel.add(generationLabel);
      southPanel.add(buttonPanel);
      setLayout(new BorderLayout());
      add(world, BorderLayout.NORTH);
      add(southPanel, BorderLayout.SOUTH);
      stepButton.addActionListener(this);
      runButton.addActionListener(this);
      stopButton.addActionListener(this);
   } //constructor

   public void actionPerformed(ActionEvent e) {
      if (e.getSource() == stepButton || e.getSource() == timer) {
         model.newGeneration();
         world.repaint();
         generationLabel.setText("Generation: " + model.getNrOfGeneration());
      }
      else if (e.getSource() == runButton) {
         timer.start();
      }
      else if (e.getSource() == stopButton) {
         timer.stop();
      }
   }//actionPerformed 
}//LifeView 
